--- main/manager.c.old  2010-07-30 16:57:27.000000000 +0300
+++ main/manager.c      2010-08-04 17:32:42.000000000 +0300
@@ -2921,14 +2921,16 @@
                                if (MAP_FAILED == (buf = mmap(NULL, l + 1, PROT_READ | PROT_WRITE, MAP_SHARED, ss.fd, 0))) {
                                        ast_log(LOG_WARNING, "mmap failed.  Manager request output was not processed\n");
                                } else {
+                                       char *newbuf = ast_malloc(l + 1);
+                                       memcpy(newbuf, buf, l);
+                                       newbuf[l] = '\0';
                                        char *tmpbuf;
-                                       buf[l] = '\0';
                                        if (format == FORMAT_XML)
-                                               tmpbuf = xml_translate(buf, params);
+                                               tmpbuf = xml_translate(newbuf, params);
                                        else if (format == FORMAT_HTML)
-                                               tmpbuf = html_translate(buf);
+                                               tmpbuf = html_translate(newbuf);
                                        else
-                                               tmpbuf = buf;
+                                               tmpbuf = newbuf;
                                        if (tmpbuf) {
                                                size_t wlen, tlen;
                                                if ((retval = malloc((wlen = strlen(workspace)) + (tlen = strlen(tmpbuf)) + 128))) {
@@ -2939,11 +2941,12 @@
                                                        len = 120;
                                                }
                                        }
-                                       if (tmpbuf != buf)
+                                       if (tmpbuf != newbuf)
                                                free(tmpbuf);
                                        free(s->outputstr);
                                        s->outputstr = NULL;
                                        munmap(buf, l + 1);
+                                       free(newbuf);
                                }
                        }
                        fclose(ss.f);
